$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! DISKSPACE -- To give a summary of the available disk space in readable
$! and interpreted form.   NAS, 11/85
$!
$! [Modified 2/87 JJT -- Add LNM$SYSTEM_TABLE to F$TRNLNM in case redefined]
$!
$! Call without arguments to list all disks, which should be set in the global
$! variable "KNOWN_DISKS" in the system login.  If this global variable is not
$! found we just do a SHOW DEV D.
$!
$! Call with up to eight parameters to list those disks
$! 
$! 9/88 - Bauer - Updated for OSB Disks, added histogram feature
$! 2/89 - Bauer - More OSB disk updates, put into DEVTOOLS
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ ON ERROR THEN GOTO error
$ set term/wid=132
$ known_disks := "DISK$ALLO/DISK$ANKY/DISK$BARNEY/DISK$BETTY/DISK$BRUNO/DISK$BRONTO/DISK$CORY/DISK$DEINO/DISK$FRED/DISK$GALILEO/DISK$HERCULES/DISK$ICHTHY/DISK$LUCY/DISK$PTERO/DISK$SHARE1/DISK$STEGO/DISK$STYRAC/DISK$TREX/DISK$TRICERO/DISK$WILMA"
$ IF P1 .EQS. "" THEN GOTO all
$!
$! One or more arguments
$!
$ disks = "''P1'"
$ extra = 1
$ parloop:
$ extra = extra + 1
$ IF P'extra' .EQS. "" THEN GOTO begin
$ disks = F$FAO ( "!3(AS)", disks, "/", P'extra' )
$ IF extra .LT. 8 THEN GOTO parloop
$ GOTO begin
$!
$! All known disks
$ all:
$ disks = "''known_disks'"
$ IF disks .EQS. "" THEN GOTO unknown
$! Global variable not set - go to "SHOW DEVICE"
$!
$ begin:
$! Write out the title lines
$ dum = 0
$ line = F$FAO ( "             !AS!%D", "OSB Disk Usage on ", dum )
$! WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT line
$! WRITE SYS$OUTPUT ""
$ line = F$FAO ( "    !10AS!15AS!11AS  !13AS   !50AS", "Volume", "Logical name", -
  "Free blocks", "Max. blocks", "% Used" )
$ WRITE SYS$OUTPUT line
$ WRITE SYS$OUTPUT ""
$! Begin processing disks
$ num = 0
$ loop:
$ diskbit = F$ELEMENT ( num, "/", disks )
$ IF diskbit .EQS. "/" THEN GOTO end
$ over = ""
$ logname = F$TRNLNM ( "''diskbit'","LNM$SYSTEM_TABLE",,,, "VALUE" )
$ IF logname .eqs. "" THEN GOTO no_trans_disk
$ free = F$GETDVI ( "''logname'", "FREEBLOCKS" )
$ max = F$GETDVI ( "''logname'", "MAXBLOCK" )
$ name = F$GETDVI ( "''logname'", "VOLNAM" )
$ percent = (max - free) * 100 / max
$ stars = percent/2
$ if percent .eq. 1 THEN stars = 1
$ scare = "    "
$ if percent .ge. 95 then scare = "[0;1;5m--> [0m"
$ star_string = "    "
$ i = 1
$ IF stars .gt. 0 then goto compute_stars
$ goto print_it
$ compute_stars: IF i .gt. stars then goto print_it
$ star_string = star_string + "."
$ i = i + 1
$ goto compute_stars
$ star_string = 
$ print_it: line = F$FAO ( "!AS!10AS!15AS!9SL!13SL   !AS!4SL%", scare, name, logname, -
 free, max, star_string, percent )
$ GOTO merge
$NO_trans_DISK:
$ line = F$FAO ("   *** Disk !AS not found on this node ***", diskbit)
$MERGE:
$ write sys$output line
$ num = num + 1
$ GOTO loop
$! Probably from getting an invalid logical name
$ error:
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Probable error in input disk names: ''disks'"
$ GOTO end
$! No known_disks variable
$ unknown:
$ SHOW DEVICE D
$ end:
$! WRITE SYS$OUTPUT ""
